﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProjectMachine
{
    internal class TankCompareByType : IComparer<IDrawningObject>
    {
        public int Compare(IDrawningObject? x, IDrawningObject? y)
        {

            if (x == null && y == null)
            {
                return 0;
            }
            if (x == null && y != null)
            {
                return 1;
            }
            if (x != null && y == null)
            {
                return -1;
            }
            var xTank = x as DrawningObject;
            var yTank = y as DrawningObject;
            if (xTank == null && yTank == null)
            {
                return 0;
            }
            if (xTank == null && yTank != null)
            {
                return 1;
            }
            if (xTank != null && yTank == null)
            {
                return -1;
            }
            if (xTank.GetTank.GetType().Name != yTank.GetTank.GetType().Name)
            {
                if (xTank.GetTank.GetType().Name == "DrawningMachine")
                {
                    return -1;
                }
                return 1;
            }
            var speedCompare =
           xTank.GetTank.Machine.Speed.CompareTo(yTank.GetTank.Machine.Speed);
            if (speedCompare != 0)
            {
                return speedCompare;
            }
            return xTank.GetTank.Machine.Weight.CompareTo(yTank.GetTank.Machine.Weight);
        }
    }
}
